package ejemplo04;

import com.fpmislata.persistencia.dao.BussinessException;
import com.fpmislata.persistencia.dao.BussinessMessage;
import com.fpmislata.persistencia.hibernate.util.HibernateUtil;
import ejemplo04.dominio.Profesor;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class Main {

    public static void main(String[] args) {
        ApplicationContext context =new ClassPathXmlApplicationContext("classpath:applicationContext.xml");
        
        HibernateUtil.buildSessionFactory();

        try {
            HibernateUtil.openSessionAndAttachToThread();

            ProfesorController profesorController=context.getBean(ProfesorController.class);
            Profesor profesor=new Profesor(null,null,null);

            profesorController.guardar(profesor);
            
        } catch (BussinessException be) {
            System.out.println("No se ha podido guardar el profesor.Se han producido los siguientes errores:");
            for (BussinessMessage bussinessMessage : be.getBussinessMessages()) {
                System.out.println(bussinessMessage.toString());
            }
        } finally {
            if (HibernateUtil.isSessionAttachToThread()) {
                HibernateUtil.closeSessionAndDeattachFromThread();
            }
        }

        HibernateUtil.closeSessionFactory();
    }
}
